REM https://download.qt.io/community_releases/5.7/5.7.1/qtwebkit-opensource-src-5.7.1.tar.xz

set P=qtwebkit-qt5
set V=5.7.1
set B=1

if "%OSGEO4W_REP%"=="" (
        echo no repository
        exit 1
)

if "%ARCH%"=="x86" (
        set OSGEO4W_ROOT=C:\OSGeo4W
        set VCARCH=x86
	copy %OSGEO4W_ROOT%\lib\zlib.lib zdll.lib
) else if "%ARCH%"=="x86_64" (
        set OSGEO4W_ROOT=C:\OSGeo4W64
        set VCARCH=amd64
	copy %OSGEO4W_ROOT%\lib\zdll.lib zdll.lib
) else (
        echo invalid arch
        exit
)

copy %OSGEO4W_ROOT%\lib\sqlite3_i.lib sqlite3.lib

set R=%OSGEO4W_REP%\%ARCH%\release\qt5\%P%
for %%i in (devel libs libs-debug qml) do (
        if not exist %R%\%P%-%%i mkdir %R%\%P%-%%i
        copy %%i.hint %R%\%P%-%%i\setup.hint
	if errorlevel 1 (echo %%i.hint not found & goto error)
)


call "%OSGEO4W_ROOT%\bin\o4w_env.bat"
call "%OSGEO4W_ROOT%\bin\qt5_env.bat"
call "c:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" %VCARCH%
path %PATH%;c:\cygwin\bin
echo on

set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\include
set LIB=%LIB%;%OSGEO4W_ROOT%\lib;%CD%


if not exist patched-qtwebkit patch -p1 <qtwebkit.diff >patched-qtwebkit

cd ..

goto skip
if exist Makefile (
	jom distclean
	if errorlevel 1 (echo clean error & goto error)
)
:skip

set QMAKE_MOC=%OSGEO4W_ROOT:\=/%/apps/Qt5/bin/moc.exe
qmake WebKit.pro
if errorlevel 1 (echo qmake error & goto error)

jom
if errorlevel 1 (echo make error & goto error)

jom install
if errorlevel 1 (echo install error & goto error)

tar --remove-files -C %OSGEO4W_ROOT% -cjvf %R%\%P%-devel\%P%-devel-%V%-%B%.tar.bz2 ^
	apps/Qt5/include/QtWebKit ^
	apps/Qt5/include/QtWebKitWidgets ^
	apps/Qt5/mkspecs/modules/qt_lib_webkit.pri ^
	apps/Qt5/mkspecs/modules/qt_lib_webkit_private.pri ^
	apps/Qt5/mkspecs/modules/qt_lib_webkitwidgets.pri ^
	apps/Qt5/mkspecs/modules/qt_lib_webkitwidgets_private.pri ^
	apps/Qt5/lib/cmake/Qt5WebKit ^
	apps/Qt5/lib/cmake/Qt5WebKitWidgets ^
	apps/Qt5/lib/Qt5WebKit.lib ^
	apps/Qt5/lib/Qt5WebKit.prl ^
	apps/Qt5/lib/Qt5WebKitWidgets.lib ^
	apps/Qt5/lib/Qt5WebKitWidgets.prl

tar --remove-files -C %OSGEO4W_ROOT% -cjvf %R%\%P%-libs\%P%-libs-%V%-%B%.tar.bz2 ^
	apps/Qt5/bin/Qt5WebKit.dll ^
	apps/Qt5/bin/Qt5WebKitWidgets.dll ^
	apps/Qt5/bin/QtWebProcess.exe ^
	apps/Qt5/plugins/webkit

tar --remove-files -C %OSGEO4W_ROOT% -cjvf %R%\%P%-libs-debug\%P%-libs-debug-%V%-%B%.tar.bz2 ^
	apps/Qt5/bin/Qt5WebKitd.dll ^
	apps/Qt5/lib/Qt5WebKitd.lib ^
	apps/Qt5/bin/Qt5WebKitd.pdb ^
	apps/Qt5/lib/Qt5WebKitd.prl ^
	apps/Qt5/bin/Qt5WebKitWidgetsd.dll ^
	apps/Qt5/lib/Qt5WebKitWidgetsd.lib ^
	apps/Qt5/bin/Qt5WebKitWidgetsd.pdb ^
	apps/Qt5/lib/Qt5WebKitWidgetsd.prl

tar --remove-files -C %OSGEO4W_ROOT% -cjvf %R%\%P%-qml\%P%-qml-%V%-%B%.tar.bz2 ^
	apps/Qt5/qml/QtWebKit

tar -cjvf %R%\%P%-libs\%P%-libs-%V%-%B%-src.tar.bz2 ^
	osgeo4w/package.cmd ^
	osgeo4w/qtwebkit.diff ^
	osgeo4w/devel.hint ^
	osgeo4w/libs.hint ^
	osgeo4w/libs-debug.hint ^
	osgeo4w/qml.hint

exit

:error
exit /b 1
